
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>

#include "utils.h"


int	pid;
struct	fdpipe	fdp;



void	hexdump (int type, unsigned char *buf, int len)
{
        register int m;
        register int n;
        register unsigned char *data;

	switch (type)
	   {
		case DATA_INPUT:
			fprintf (stderr, "input : %d bytes\n", len);
			break;
		case DATA_OUTPUT:
			fprintf (stderr, "output: %d bytes\n", len);
			break;
	   }

        data=buf;
        for (m=0;m<len;m++)
           {
                if( (!(m%2)) && (m!=0) ) fprintf (stderr, " ");
                if( (!(m%20)) && (m!=0) )
                   {
                        n=m;
                        for (n=20;n>0;n--)
                           {
                                if ((*(data+m-n)>31) && (*(data+m-n)<127))
                                        fprintf (stderr, "%c", *(data+m-n));
                                else
                                        fprintf (stderr, ".");
                           }
                        fprintf (stderr, "\n");
                   }
                fprintf (stderr, "%02x",*(data+m));
           }

        for (m=0;m<(20-((len%20)?(len%20):20))*2+(10-((len%20)?(len%20-1):19)/2);m++) fprintf (stderr, " ");

        for (m=len-((len%20)?(len%20):20);m<len;m++)
           {
                if ((*(data+m)>31) && (*(data+m)<127))
                        fprintf (stderr, "%c", *(data+m));
                else
                        fprintf (stderr, ".");
           }
   fprintf (stderr, "\n\n");
}



struct fdpipe	*x_popen (char *command)
{
	int	p_read[2], p_write[2];

	if (pipe(p_read) < 0)
	   {
		perror ("pipe");
		return NULL;
	   }

	if (pipe(p_write) < 0)
	   {
		perror ("pipe");
		return NULL;
	   }

	switch ((pid = fork()))
	   {
		int	i;

		case -1:
			perror ("fork");
			close (p_write[0]);
			close (p_write[1]);
			close (p_read [0]);
			close (p_read [1]);
			return NULL;
		case 0:
			dup2 (p_write[0], STDIN_FILENO);
			dup2 (p_read [1], STDOUT_FILENO);
			dup2 (p_read [1], STDERR_FILENO);

			for (i = STDERR_FILENO + 1; i < 16; i++)
			   {
				close(i);
			   }

			setsid ();

			if ( execl (command, command, NULL) == -1 )
			   {
				perror ("exec");
				exit (1);
			   }
		default:
			break;
	   }

	close (p_read [1]);
	close (p_write[0]);

	fdp.pip_read  = p_read [0];
	fdp.pip_write = p_write[1];

	return &fdp;
}



int	x_pclose ()
{
	if (pid) kill (pid, SIGINT);

	close (fdp.pip_read);
	close (fdp.pip_write);

	return (0);
}


